// ============================= F28335 BIOS α׷ =========================
//  CPU : TMS320F28335-150M
//     ¥ : 2009-
//      : Ver1.0
//    : www.cpuplaza.com
// Ϸ : CCS3.3
// [ ]  : OSC 30M
// ----------------------------------------------------------------------------
#include "DSP2833x_Device.h"					// Peripheral address definitions
#include "F28335_example.h"					// Main include file

//  

// ===============================  α׷ ==============================
// [μ] void
// ---------------------------------------------------------------------------
void main(void)
{
	InitSysCtrl();						// Initialize the CPU
	InitPieCtrl();						// Initialize and enable the PIE
	InitWatchdog();						// Initialize the Watchdog Timer
	InitGpio();							// Initialize the shared GPIO pins
	InitXintf();						// Initialize the external memory interface

#ifdef EXAMPLE_FLASH						// EXAMPLE_FLASH, if defined, is in CCS project options
// Copy all Flash sections that need to run from RAM (use memcpy() from RTS library)
// Section secureRamFuncs contains user defined code that runs from CSM secured RAM
	memcpy(	&secureRamFuncs_runstart,&secureRamFuncs_loadstart,&secureRamFuncs_loadend - &secureRamFuncs_loadstart);
// Initialize the Flash and OTP
	InitFlash();						// Initialize the Flash
#endif

// Enable interrupts
	SetDBGIER(IER | 0x6000);				// Enable everything in IER, plus TINT2 and DLOGINT
	*(volatile unsigned int *)0x00000C14 |= 0x0C00;		// Set TIMER2 FREE=SOFT=1
// main()  ϸ DSP/BIOS ..

}

// ================================ UserInit =================================
// [μ] void
// [] Description: This is the user initialization file to be specified in
//	  the DSP/BIOS configuration file, System - Global Settings.
// ---------------------------------------------------------------------------
void UserInit(void)
{
#ifdef EXAMPLE_FLASH						// EXAMPLE_FLASH, if defined, is in CCS project options

// Section .trcdata is generated by DSP/BIOS.
// It must be copied from its load to its run address BEFORE main().
	memcpy(&trcdata_runstart, &trcdata_loadstart, &trcdata_loadend - &trcdata_loadstart);

#endif
}

// ============================  Ÿ Ÿũ1 =====================
// [μ] void
// --------------------------------------------------------------------
void task1_proc(void)
{
	while(1) {
		TSK_sleep(1);
	}
}
